Imports Microsoft.VisualBasic
Imports System.Data.Odbc
Imports System.Data
Imports System.Web
Imports ChartDirector

' ---------------------------------------------------------------------------
' Filename:			GRAPH.vb
' By:				Steph@ne
' Created:			14-11-2010
' Updated:			18-11-2010
' Version:			1.1
' Use:				Recup les temprature du salon et de l'exterieur
' InsertionDB()			insert les valeurs des 15 devices en DB
' CreateChart()			Cre un graphique en ligne suivant paramtrage
' 						dans graph.ini
'
'v1.1				Cration de tous les graphiques en mme temps
'					Ajout de System.data;System.Data.dll automatiquement dans settings.ini
'					Cration automatique de l'event recurent.
' ---------------------------------------------------------------------------

sub initialisation(param as string)
	hs.writelog("GRAPH.vb","Vrification de l'vnement.")
	if hs.EventExists(hs.GetINISetting("temperature", "EventNom", "", "GRAPH.ini")) then hs.DeleteEvent(hs.GetINISetting("temperature", "EventNom", "", "GRAPH.ini"))
	Dim eve As Scheduler.Classes.EventClass._EventClass
	dim ref as long
	dim script as string
	hs.writelog("GRAPH.vb","Cration de l'vnement " & hs.GetINISetting("temperature", "EventNom", "", "GRAPH.ini") & " toutes les " & hs.GetINISetting("temperature", "EventAuto", "", "GRAPH.ini") & " mn" )
	ref=hs.NewEventGetRef(hs.GetINISetting("temperature", "EventNom", "", "GRAPH.ini"))
	eve=hs.GetEventByRef(ref)
	eve.ev_abs_time=6
	eve.rec_mins=hs.GetINISetting("temperature", "EventAuto", "", "GRAPH.ini")
	eve.group="Graphiques"
	hs.clearactions(ref)
	script="&hs.runex(""GRAPH.vb"",""Main"","" "")"
	hs.addaction(ref,5,script)
	hs.EnableEvent(hs.GetINISetting("temperature", "EventNom", "", "GRAPH.ini"))
	eve=nothing
	hs.writelog("GRAPH.vb","Vrification de settings.ini.")
	Dim parametre as string = "System.data;System.Data.dll"
	Dim TrouveParametre as integer = InStr(hs.GetINISetting("Settings", "ScriptingReferences", "", "settings.ini"),parametre)
	if TrouveParametre=0 then
		hs.writelog("GRAPH.vb","Paramtre dans settings.ini manquant.")
		hs.SaveINISetting("settings","ScriptingReferences",hs.GetINISetting("Settings", "ScriptingReferences", "", "settings.ini") & "," & parametre,"settings.ini")
		hs.writelog("GRAPH.vb","Paramtre dans settings.ini ajout. Redmarrer Homeseer")
	Else
		hs.writelog("GRAPH.vb","Paramtre dans settings.ini trouv. Pas d'action.")
	End if
End Sub

Sub Main(parm as string)
	InsertionDB("")
	dim graph() as string = hs.GetINISetting("temperature", "GraphAuto", "", "GRAPH.ini").split(",")
	dim i as integer
	For i=lbound(graph) to ubound(graph)
	CreateChart(graph(i))
	Next
End Sub

' --------------- Creation du graphique lignes
Sub CreateChart(graphique as string) 
	
	if graphique<>"" then
	
			Dim ConnectionString as String = hs.GetINISetting("temperature", "ConnectionString", "", "GRAPH.ini")
			Dim connection As OdbcConnection
			Dim aCommand As OdbcCommand
			Dim reader
			connection = New OdbcConnection()
			connection.ConnectionString = ConnectionString
			connection.Open()
         
			Dim strQuery as String="SELECT DateTemperature , " & hs.GetINISetting(graphique, "Devicex", "", "GRAPH.ini") & " FROM Temperaturesheure WHERE DateTemperature>DATEADD ('h',-24,now()) order by datetemperature asc;"
			aCommand = New OdbcCommand(strQuery, connection)
			Reader = aCommand.ExecuteReader(CommandBehavior.CloseConnection)
	
			dim dev1, dev2, dev3, dev4, dev5, dev6, dev7, dev8, dev9, dev10, dev11, dev12, dev13, dev14, dev15 as boolean
			Dim selection() as string = hs.GetINISetting(graphique, "Devicex", "", "GRAPH.ini").split(",")
			Dim a as integer
			
			For a=lbound(selection) to ubound(selection)
				if lcase(selection(a))="device1" then dev1=true
				if lcase(selection(a))="device2" then dev2=true
				if lcase(selection(a))="device3" then dev3=true
				if lcase(selection(a))="device4" then dev4=true
				if lcase(selection(a))="device5" then dev5=true
				if lcase(selection(a))="device6" then dev6=true
				if lcase(selection(a))="device7" then dev7=true
				if lcase(selection(a))="device8" then dev8=true
				if lcase(selection(a))="device9" then dev9=true
				if lcase(selection(a))="device10" then dev10=true
				if lcase(selection(a))="device11" then dev11=true
				if lcase(selection(a))="device12" then dev12=true
				if lcase(selection(a))="device13" then dev13=true
				if lcase(selection(a))="device14" then dev14=true
				if lcase(selection(a))="device15" then dev15=true
			Next
	
			Dim device1() As Double = {0}
			Dim device2() As Double = {0}
			Dim device3() As Double = {0}
			Dim device4() As Double = {0}
			Dim device5() As Double = {0}
			Dim device6() As Double = {0}
			Dim device7() As Double = {0}
			Dim device8() As Double = {0}
			Dim device9() As Double = {0}
			Dim device10() As Double = {0}
			Dim device11() As Double = {0}
			Dim device12() As Double = {0}
			Dim device13() As Double = {0}
			Dim device14() As Double = {0}
			Dim device15() As Double = {0}
			Dim DateTemp() As date
			Dim Compteur As Long =0
        
			While reader.Read()
				ReDim Preserve Device1(compteur)
				ReDim Preserve Device2(compteur)
				ReDim Preserve Device3(compteur)
				ReDim Preserve Device4(compteur)
				ReDim Preserve Device5(compteur)
				ReDim Preserve Device6(compteur)
				ReDim Preserve Device7(compteur)
				ReDim Preserve Device8(compteur)
				ReDim Preserve Device9(compteur)
				ReDim Preserve Device10(compteur)
				ReDim Preserve Device11(compteur)
				ReDim Preserve Device12(compteur)
				ReDim Preserve Device13(compteur)
				ReDim Preserve Device14(compteur)
				ReDim Preserve Device15(compteur)
				ReDim Preserve DateTemp(compteur)
		
				if dev1=true then device1(Compteur) = reader("Device1").ToString()
				if dev2=true then device2(Compteur) = reader("Device2").ToString()
				if dev3=true then device3(Compteur) = reader("Device3").ToString()
				if dev4=true then device4(Compteur) = reader("Device4").ToString()
				if dev5=true then device5(Compteur) = reader("Device5").ToString()
				if dev6=true then device6(Compteur) = reader("Device6").ToString()
				if dev7=true then device7(Compteur) = reader("Device7").ToString()
				if dev8=true then device8(Compteur) = reader("Device8").ToString()
				if dev9=true then device9(Compteur) = reader("Device9").ToString()
				if dev10=true then device10(Compteur) = reader("Device10").ToString()
				if dev11=true then device11(Compteur) = reader("Device11").ToString()
				if dev12=true then device12(Compteur) = reader("Device12").ToString()
				if dev13=true then device13(Compteur) = reader("Device13").ToString()
				if dev14=true then device14(Compteur) = reader("Device14").ToString()
				if dev15=true then device15(Compteur) = reader("Device15").ToString()
				DateTemp(Compteur) = reader("DateTemperature").tostring()
				Compteur=Compteur+1
			End While
        
			Dim c As XYChart = New XYChart(hs.GetINISetting(graphique, "LargeurPx", "", "GRAPH.ini"), hs.GetINISetting(graphique, "HauteurPx", "", "GRAPH.ini"),hs.GetINISetting(graphique, "CouleurFond", "", "GRAPH.ini"), &H0, 0)
			chart.setLicenseCode("SBWTDH883563W6GG7218B192")
			if hs.GetINISetting(graphique, "Titre", "", "GRAPH.ini")<>"" then 
				c.setPlotArea(30, 20, hs.GetINISetting(graphique, "LargeurPx", "", "GRAPH.ini")-40, hs.GetINISetting(graphique, "HauteurPx", "", "GRAPH.ini")-60,&H0FF000000,-1,-1,&H0FF000000)  
			Else
				c.setPlotArea(30, 10, hs.GetINISetting(graphique, "LargeurPx", "", "GRAPH.ini")-40, hs.GetINISetting(graphique, "HauteurPx", "", "GRAPH.ini")-40,&H0FF000000,-1,-1,&H0FF000000)  
			End If
			
			Dim layer As LineLayer = c.addLineLayer2()
			if dev1=true then layer.addDataSet(device1,-1, hs.stringitem(hs.GetINISetting("Temperature", "Device1", "", "GRAPH.ini"),3,"|"))
			if dev2=true then layer.addDataSet(device2, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device2", "", "GRAPH.ini"),3,"|"))
			if dev3=true then layer.addDataSet(device3, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device3", "", "GRAPH.ini"),3,"|"))
			if dev4=true then layer.addDataSet(device4, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device4", "", "GRAPH.ini"),3,"|"))
			if dev5=true then layer.addDataSet(device5, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device5", "", "GRAPH.ini"),3,"|"))
			if dev6=true then layer.addDataSet(device6, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device6", "", "GRAPH.ini"),3,"|"))
			if dev7=true then layer.addDataSet(device7, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device7", "", "GRAPH.ini"),3,"|"))
			if dev8=true then layer.addDataSet(device8, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device8", "", "GRAPH.ini"),3,"|"))
			if dev9=true then layer.addDataSet(device9, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device9", "", "GRAPH.ini"),3,"|"))
			if dev10=true then layer.addDataSet(device10, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device10", "", "GRAPH.ini"),3,"|"))
			if dev11=true then layer.addDataSet(device11, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device11", "", "GRAPH.ini"),3,"|"))
			if dev12=true then layer.addDataSet(device12, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device12", "", "GRAPH.ini"),3,"|"))
			if dev13=true then layer.addDataSet(device13, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device13", "", "GRAPH.ini"),3,"|"))
			if dev14=true then layer.addDataSet(device14, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device14", "", "GRAPH.ini"),3,"|"))
			if dev15=true then layer.addDataSet(device15, -1, hs.stringitem(hs.GetINISetting("Temperature", "Device15", "", "GRAPH.ini"),3,"|"))
        
			layer.setXData(DateTemp)
			layer.setLineWidth(hs.GetINISetting(graphique, "LargeurLignes", "", "GRAPH.ini"))
			c.xAxis.setDateScale("{value|hh}")
			c.xAxis().setLabelStyle(hs.GetINISetting(graphique, "Font", "", "GRAPH.ini"), hs.GetINISetting(graphique, "TexteTaille", "", "GRAPH.ini"), hs.GetINISetting(graphique, "TexteCouleur", "", "GRAPH.ini"))
			c.yAxis().setLabelStyle(hs.GetINISetting(graphique, "Font", "", "GRAPH.ini"), hs.GetINISetting(graphique, "TexteTaille", "", "GRAPH.ini"), hs.GetINISetting(graphique, "TexteCouleur", "", "GRAPH.ini"))
			if hs.GetINISetting(graphique, "Titre", "", "GRAPH.ini")<>"" then c.addTitle(hs.GetINISetting(graphique, "Titre", "", "GRAPH.ini"),hs.GetINISetting(graphique, "font", "", "GRAPH.ini"),cint(hs.GetINISetting(graphique, "TitreTaille", "", "GRAPH.ini")),cint(hs.GetINISetting(graphique, "TitreCouleur", "", "GRAPH.ini")))
			if hs.GetINISetting(graphique, "Legende", "", "GRAPH.ini")=1 then c.addLegend(30,hs.GetINISetting(graphique, "HauteurPx", "", "GRAPH.ini")-25, False, hs.GetINISetting(graphique, "Font", "", "GRAPH.ini"), 7).setBackground(Chart.Transparent)
			c.makeChart(hs.GetINISetting(graphique, "CheminFichier", "", "GRAPH.ini"))
			c=nothing
		
			connection.Close()
			connection.dispose()
			connection=nothing
			

		
	else
		hs.writelog("GRAPH","Paramtre manquant. Le script ne s'xcute pas.")
	end if
End Sub

sub InsertionDB(parm as object)
		
    Dim Device1() As String = hs.GetINISetting("temperature", "Device1", "", "GRAPH.ini").Split("|")
    Dim Device2() As String = hs.GetINISetting("temperature", "Device2", "", "GRAPH.ini").Split("|")
    Dim Device3() As String = hs.GetINISetting("temperature", "Device3", "", "GRAPH.ini").Split("|")
    Dim Device4() As String = hs.GetINISetting("temperature", "Device4", "", "GRAPH.ini").Split("|")
    Dim Device5() As String = hs.GetINISetting("temperature", "Device5", "", "GRAPH.ini").Split("|")
    Dim Device6() As String = hs.GetINISetting("temperature", "Device6", "", "GRAPH.ini").Split("|")
    Dim Device7() As String = hs.GetINISetting("temperature", "Device7", "", "GRAPH.ini").Split("|")
    Dim Device8() As String = hs.GetINISetting("temperature", "Device8", "", "GRAPH.ini").Split("|")
    Dim Device9() As String = hs.GetINISetting("temperature", "Device9", "", "GRAPH.ini").Split("|")
    Dim Device10() As String = hs.GetINISetting("temperature", "Device10", "", "GRAPH.ini").Split("|")
    Dim Device11() As String = hs.GetINISetting("temperature", "Device11", "", "GRAPH.ini").Split("|")
    Dim Device12() As String = hs.GetINISetting("temperature", "Device12", "", "GRAPH.ini").Split("|")
    Dim Device13() As String = hs.GetINISetting("temperature", "Device13", "", "GRAPH.ini").Split("|")
    Dim Device14() As String = hs.GetINISetting("temperature", "Device14", "", "GRAPH.ini").Split("|")
    Dim Device15() As String = hs.GetINISetting("temperature", "Device15", "", "GRAPH.ini").Split("|")

    Dim InsertString As String
    InsertString = "INSERT INTO Temperaturesheure(datetemperature"
    If Device1(0) <> "" Then InsertString = InsertString & ",device1"
    If Device2(0) <> "" Then InsertString = InsertString & ",device2"
    If Device3(0) <> "" Then InsertString = InsertString & ",device3"
    If Device4(0) <> "" Then InsertString = InsertString & ",device4"
    If Device5(0) <> "" Then InsertString = InsertString & ",device5"
    If Device6(0) <> "" Then InsertString = InsertString & ",device6"
    If Device7(0) <> "" Then InsertString = InsertString & ",device7"
    If Device8(0) <> "" Then InsertString = InsertString & ",device8"
    If Device9(0) <> "" Then InsertString = InsertString & ",device9"
    If Device10(0) <> "" Then InsertString = InsertString & ",device10"
    If Device11(0) <> "" Then InsertString = InsertString & ",device11"
    If Device12(0) <> "" Then InsertString = InsertString & ",device12"
    If Device13(0) <> "" Then InsertString = InsertString & ",device13"
    If Device14(0) <> "" Then InsertString = InsertString & ",device14"
    If Device15(0) <> "" Then InsertString = InsertString & ",device15"
    InsertString = InsertString & ") VALUES(now()"
    If Device1(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device1(0)) / Device1(1)), ",", ".")
    If Device2(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device2(0)) / Device2(1)), ",", ".")
    If Device3(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device3(0)) / Device3(1)), ",", ".")
    If Device4(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device4(0)) / Device4(1)), ",", ".")
    If Device5(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device5(0)) / Device5(1)), ",", ".")
    If Device6(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device6(0)) / Device6(1)), ",", ".")
    If Device7(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device7(0)) / Device7(1)), ",", ".")
    If Device8(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device8(0)) / Device8(1)), ",", ".")
    If Device9(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device9(0)) / Device9(1)), ",", ".")
    If Device10(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device10(0)) / Device10(1)), ",", ".")
    If Device11(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device11(0)) / Device11(1)), ",", ".")
    If Device12(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device12(0)) / Device12(1)), ",", ".")
    If Device13(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device13(0)) / Device13(1)), ",", ".")
    If Device14(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device14(0)) / Device14(1)), ",", ".")
    If Device15(0) <> "" Then InsertString = InsertString & "," & replace(cdec(hs.DeviceValue(Device15(0)) / Device15(1)), ",", ".")
    InsertString = InsertString & ");"
	

    Dim connection As OdbcConnection
    Dim aCommand As OdbcCommand
    Dim ConnectionString As String = hs.GetINISetting("temperature", "ConnectionString", "", "GRAPH.ini")
    Dim modelog As String = hs.GetINISetting("Temperature", "ModeLog", "", "GRAPH.ini")
		
	connection = New OdbcConnection()
    connection.ConnectionString = ConnectionString
    connection.Open()
    If modelog = True Then hs.WriteLog("InsertionDB", "Connexion  la base de donne")
    aCommand = New Odbc.OdbcCommand(InsertString, connection)
    aCommand.ExecuteNonQuery()
    If modelog = True Then hs.WriteLog("InsertionDB", "Insertion des valeurs")
    connection.Close()
	connection.dispose()
    connection = Nothing
    aCommand = Nothing
	ConnectionString = Nothing

    If modelog = True Then hs.WriteLog("InsertionDB", "Opration termine")

End Sub